##############################################################################
# Module : commandline.py
# Author : Old King Cole
# Date   : 20 August 2007
#
# Description : Handles command line
#
##############################################################################
from sys import getwindowsversion

from win32con import VER_PLATFORM_WIN32_NT
from ctypes import windll, c_wchar_p, c_void_p, c_int, POINTER, byref


def getCommandLine():
    # Workaround to get Unicode from command line
    GetCommandLineW = windll.kernel32.GetCommandLineW
    GetCommandLineW.restype = c_wchar_p
    cl = GetCommandLineW()
    winver = getwindowsversion()[3]
    arg = []
    if winver == VER_PLATFORM_WIN32_NT:
        CommandLineToArgvW = windll.shell32.CommandLineToArgvW
        CommandLineToArgvW.argtypes = [c_wchar_p, c_void_p]
        CommandLineToArgvW.restype = POINTER(c_wchar_p * 10)
        argc = c_int()
        argcarg = CommandLineToArgvW(cl, byref(argc))
        for i in xrange(argc.value):
            arg.append(argcarg.contents[i])
    else:
        # Simple command line parser for Windows 9x
        cllen = len(cl)
        i = 0
        beg = 0
        while i < cllen:
            while i < cllen and cl[i] != '"':
                i += 1
            if i != beg:
                arg.extend(cl[beg:i].split())
            if i == cllen:
                break
            i += 1
            beg = i
            while i < cllen and cl[i] != '"':
                i += 1
            arg.append(cl[beg:i])
            i += 1
            beg = i

    # As the command line is not the same if you start ABC with your Python interpreter
    # or after compilation, we make arg start with the first parameter containing "abc" ;
    # if not found (maybe abc.exe was renamed) start from parameter 0
    abcfound = False
    for i in xrange(len(arg)):
        if 'abc' in arg[i]:
            abcfound = True
            break
    if abcfound and i != 0:
        arg = arg[i:]

    return arg
